
/* PC1450 - A calculator emulator
 * Copyright (C) 1996 - 2001 Yves Maingoy
 * ymaingoy@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
    memory.h
    Liste des registres internes et blocs memoires du PC1450
*/

#define sizebuf 65536

extern void SaveMemory(char *FicName);
extern void LoadMemory(char *FicName);  // lecture de la rom et de la ram
extern void initRegs();
extern void WriteIni(void);
extern void ReadIni(void);
char pc1450mem[256];                    // = "PC1450.RAM";
char FileNameLOAD[256];                 // = "exemple.bas";
char FileNameSAVE[256];                 // = "exemple.bas";
extern int NoROMLoaded;                 // = 0 si une erreur au load !

extern void  pokePC(unsigned short adr,unsigned char byte);
extern unsigned char  peekPC(unsigned short adr);
extern unsigned short dpeekPC(unsigned short adr);
extern unsigned char  peekDP(unsigned short adr);
extern unsigned short dpeekDP(unsigned short adr);

extern  unsigned short PC;
extern  unsigned short DP;
extern  unsigned char KeyPort;
extern int readKeyStatus(void);

extern int isScreenRefresh;     /* != 0 si l'ecran doit etre rafraichi */


extern  int CLK;                /* !=0 si CLK ON */
extern  int DebugMode;
extern  int FinPrgm;
extern  long Horloge512;        /* 512 ms */
extern  long Horloge002;        /* 002 ms */
extern  long MaxHorloge512;     /* calibrage de l'horloge 512 en cycles */
extern  long MaxHorloge002;     /* calibrage de l'horloge 002 en cycles */
extern  int isHorloge512;       /* != 0 si 512 ms de passees */
extern  int isHorloge002;       /* != 0 si 002 ms de passees */

extern  int isTouchePresente;   /* !=0 si une touche a lire */
extern int BreakOn;
extern  unsigned char MemoryBuffer[sizebuf]; // Buffer RAM + ROM

char RamType;                   // par defaut: 16 Ko */
int MaxDelay;                   // valeur entre 0 et 32000 pour un delai entre 2 instructions

